<html>
<head>
<title>OGRE: Ogre::CompositorInstance Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1CompositorInstance.html">CompositorInstance</a></div>
<h1>Ogre::CompositorInstance Class Reference</h1><!-- doxytag: class="Ogre::CompositorInstance" -->An instance of a <a class="el" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> object for one <a class="el" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1CompositorInstance-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; int, <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#7a0c1dcc7720e06ae1d639d0aa788172">QuadMaterialMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::pair<br>
&lt; int,<br>
 <a class="el" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html">RenderSystemOperation</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#b03be79964e60192fc2d4446b81b29fe">RenderSystemOpPair</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1CompositorInstance.html#b03be79964e60192fc2d4446b81b29fe">RenderSystemOpPair</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#be1fafc9b94e4833ec62ce008c3a2bd6">RenderSystemOpPairs</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#542cbb4277495b83ae702f991c599779">CompiledState</a></td></tr>

<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#fab0b5b480729d9f2abb6c2539ebc175">CompositorInstance</a> (<a class="el" href="classOgre_1_1Compositor.html">Compositor</a> *filter, <a class="el" href="classOgre_1_1CompositionTechnique.html">CompositionTechnique</a> *technique, <a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a> *chain)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#c31217edeab3160905ec1e367eda7c17">~CompositorInstance</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#2d4798f79dc9cce935815344e8d1bd85">setEnabled</a> (bool value)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set enabled flag.  <a href="#2d4798f79dc9cce935815344e8d1bd85"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#8620251cbeb5e1458a7438e61ce2854f">getEnabled</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get enabled flag.  <a href="#8620251cbeb5e1458a7438e61ce2854f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#cac5055f9720fb9b06edffda461e2ebb">getTextureInstanceName</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the instance name for a local texture.  <a href="#cac5055f9720fb9b06edffda461e2ebb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#b021ecbc3214d82a8ce2702f95e21986">_compileTargetOperations</a> (<a class="el" href="classOgre_1_1CompositorInstance.html#542cbb4277495b83ae702f991c599779">CompiledState</a> &amp;compiledState)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Recursively collect target states (except for final <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>).  <a href="#b021ecbc3214d82a8ce2702f95e21986"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#5e916aa434bd181800d745ecbaf7399b">_compileOutputOperation</a> (<a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &amp;finalState)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Compile the final (output) operation.  <a href="#5e916aa434bd181800d745ecbaf7399b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Compositor.html">Compositor</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#714fa12866adad893086d5e9bbc8ca7d">getCompositor</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get <a class="el" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> of which this is an instance.  <a href="#714fa12866adad893086d5e9bbc8ca7d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositionTechnique.html">CompositionTechnique</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#3b91d482e4ab59da5165f021e5db6d83">getTechnique</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get <a class="el" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> used by this instance.  <a href="#3b91d482e4ab59da5165f021e5db6d83"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#e72e37d6f305e6ae1f1014336e9e2f4b">getChain</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get Chain that this instance is part of.  <a href="#e72e37d6f305e6ae1f1014336e9e2f4b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#d2dcb9ae6aa4e0dfc0843a4cab32f800">addListener</a> (<a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a> *l)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a listener.  <a href="#d2dcb9ae6aa4e0dfc0843a4cab32f800"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#f0e83615e807bcadef8d6024cda6ec7d">removeListener</a> (<a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a> *l)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove a listener.  <a href="#f0e83615e807bcadef8d6024cda6ec7d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#62c2d7f611437483668ccf250a4841b9">_fireNotifyMaterialSetup</a> (<a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> pass_id, <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;mat)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Notify listeners of a material compilation.  <a href="#62c2d7f611437483668ccf250a4841b9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#356f66a6f94b53ebbe1fee71f219bfaf">_fireNotifyMaterialRender</a> (<a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> pass_id, <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;mat)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Notify listeners of a material render.  <a href="#356f66a6f94b53ebbe1fee71f219bfaf"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="classOgre_1_1TexturePtr.html">TexturePtr</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#a376bba92a454473511b2d85dd7a1bf1">LocalTextureMap</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Map from name-&gt;local texture.  <a href="#a376bba92a454473511b2d85dd7a1bf1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::vector<br>
&lt; <a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a> * &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#6a4983aa7ac3560bd2b0f2eb05c3a917">Listeners</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Vector of listeners.  <a href="#6a4983aa7ac3560bd2b0f2eb05c3a917"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#71e09eaa840d87b42bc149c06aa3e0ff">collectPasses</a> (<a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &amp;finalState, <a class="el" href="classOgre_1_1CompositionTargetPass.html">CompositionTargetPass</a> *target)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Collect rendering passes.  <a href="#71e09eaa840d87b42bc149c06aa3e0ff"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#b730d261e3ce8c2d3dbd675f056e8966">createLocalMaterial</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a local dummy material with one technique but no passes.  <a href="#b730d261e3ce8c2d3dbd675f056e8966"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#909fc5fda3e32e14a32bfde7b44d4a6a">createResources</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create local rendertextures and other resources.  <a href="#909fc5fda3e32e14a32bfde7b44d4a6a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#a594fe3eaf57f5e206e5d4c847d77074">freeResources</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destroy local rendertextures and other resources.  <a href="#a594fe3eaf57f5e206e5d4c847d77074"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1RenderTarget.html">RenderTarget</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#a7f2a073b8295994eb1d0c73dcb9f166">getTargetForTex</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get <a class="el" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> for a named local texture.  <a href="#a7f2a073b8295994eb1d0c73dcb9f166"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#1a3f491817519cfdf1824222dcdf6ea6">getSourceForTex</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get source texture name for a named local texture.  <a href="#1a3f491817519cfdf1824222dcdf6ea6"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#a251665019c7f50e2920c317e842d933">queueRenderSystemOp</a> (<a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &amp;finalState, <a class="el" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html">RenderSystemOperation</a> *op)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Queue a render system operation.  <a href="#a251665019c7f50e2920c317e842d933"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Compositor.html">Compositor</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#d527be1fedec4112efe9eb3ff8f6b925">mCompositor</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight"><a class="el" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> of which this is an instance.  <a href="#d527be1fedec4112efe9eb3ff8f6b925"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositionTechnique.html">CompositionTechnique</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#3d3a380fb753ad28cc3119d0f15868a4">mTechnique</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Composition technique used by this instance.  <a href="#3d3a380fb753ad28cc3119d0f15868a4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#beb0b38cce2a6c765390544d054a75cf">mChain</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Composition chain of which this instance is part.  <a href="#beb0b38cce2a6c765390544d054a75cf"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#e14d9e70c48e35de5a49ebf29777a8f7">mEnabled</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Is this instance enabled?  <a href="#e14d9e70c48e35de5a49ebf29777a8f7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositorInstance.html#a376bba92a454473511b2d85dd7a1bf1">LocalTextureMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#fb44967dff9b29465e5e5ea7aa9d67ff">mLocalTextures</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositorInstance.html#6a4983aa7ac3560bd2b0f2eb05c3a917">Listeners</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#4476eeba8785b7684dcc83e3a8bb7d31">mListeners</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1CompositorInstance.html">CompositorInstance</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#cdac0c97861080d95c032ef8c21721e3">mPreviousInstance</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Previous instance (set by chain).  <a href="#cdac0c97861080d95c032ef8c21721e3"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance.html#37ae5ce58afd2f0684c967bb1e780f58">CompositorChain</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Provides an interface to "listen in" to to render system operations executed by this <a class="el" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a>.  <a href="classOgre_1_1CompositorInstance_1_1Listener.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html">RenderSystemOperation</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Specific render system operation.  <a href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Operation setup for a <a class="el" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> (collected).  <a href="classOgre_1_1CompositorInstance_1_1TargetOperation.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
An instance of a <a class="el" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> object for one <a class="el" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>. 
<p>
It is part of the <a class="el" href="classOgre_1_1CompositorChain.html" title="Chain of compositor effects applying to one viewport.">CompositorChain</a> for a <a class="el" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>. 
<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00042">42</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="7a0c1dcc7720e06ae1d639d0aa788172"></a><!-- doxytag: member="Ogre::CompositorInstance::QuadMaterialMap" ref="7a0c1dcc7720e06ae1d639d0aa788172" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;int, <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a>&gt; <a class="el" href="classOgre_1_1CompositorInstance.html#7a0c1dcc7720e06ae1d639d0aa788172">Ogre::CompositorInstance::QuadMaterialMap</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00087">87</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b03be79964e60192fc2d4446b81b29fe"></a><!-- doxytag: member="Ogre::CompositorInstance::RenderSystemOpPair" ref="b03be79964e60192fc2d4446b81b29fe" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::pair&lt;int, <a class="el" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html">RenderSystemOperation</a>*&gt; <a class="el" href="classOgre_1_1CompositorInstance.html#b03be79964e60192fc2d4446b81b29fe">Ogre::CompositorInstance::RenderSystemOpPair</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00088">88</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="be1fafc9b94e4833ec62ce008c3a2bd6"></a><!-- doxytag: member="Ogre::CompositorInstance::RenderSystemOpPairs" ref="be1fafc9b94e4833ec62ce008c3a2bd6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1CompositorInstance.html#b03be79964e60192fc2d4446b81b29fe">RenderSystemOpPair</a>&gt; <a class="el" href="classOgre_1_1CompositorInstance.html#be1fafc9b94e4833ec62ce008c3a2bd6">Ogre::CompositorInstance::RenderSystemOpPairs</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00089">89</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="542cbb4277495b83ae702f991c599779"></a><!-- doxytag: member="Ogre::CompositorInstance::CompiledState" ref="542cbb4277495b83ae702f991c599779" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a>&gt; <a class="el" href="classOgre_1_1CompositorInstance.html#542cbb4277495b83ae702f991c599779">Ogre::CompositorInstance::CompiledState</a>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00145">145</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="a376bba92a454473511b2d85dd7a1bf1"></a><!-- doxytag: member="Ogre::CompositorInstance::LocalTextureMap" ref="a376bba92a454473511b2d85dd7a1bf1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>,<a class="el" href="classOgre_1_1TexturePtr.html">TexturePtr</a>&gt; <a class="el" href="classOgre_1_1CompositorInstance.html#a376bba92a454473511b2d85dd7a1bf1">Ogre::CompositorInstance::LocalTextureMap</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Map from name-&gt;local texture. 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00219">219</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="6a4983aa7ac3560bd2b0f2eb05c3a917"></a><!-- doxytag: member="Ogre::CompositorInstance::Listeners" ref="6a4983aa7ac3560bd2b0f2eb05c3a917" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a>*&gt; <a class="el" href="classOgre_1_1CompositorInstance.html#6a4983aa7ac3560bd2b0f2eb05c3a917">Ogre::CompositorInstance::Listeners</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Vector of listeners. 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00223">223</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="fab0b5b480729d9f2abb6c2539ebc175"></a><!-- doxytag: member="Ogre::CompositorInstance::CompositorInstance" ref="fab0b5b480729d9f2abb6c2539ebc175" args="(Compositor *filter, CompositionTechnique *technique, CompositorChain *chain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::CompositorInstance::CompositorInstance           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Compositor.html">Compositor</a> *&nbsp;</td>
          <td class="paramname"> <em>filter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositionTechnique.html">CompositionTechnique</a> *&nbsp;</td>
          <td class="paramname"> <em>technique</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a> *&nbsp;</td>
          <td class="paramname"> <em>chain</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="c31217edeab3160905ec1e367eda7c17"></a><!-- doxytag: member="Ogre::CompositorInstance::~CompositorInstance" ref="c31217edeab3160905ec1e367eda7c17" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::CompositorInstance::~CompositorInstance           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="2d4798f79dc9cce935815344e8d1bd85"></a><!-- doxytag: member="Ogre::CompositorInstance::setEnabled" ref="2d4798f79dc9cce935815344e8d1bd85" args="(bool value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::setEnabled           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>value</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Set enabled flag. 
<p>
The compositor instance will only render if it is enabled, otherwise it is pass-through. 
</div>
</div><p>
<a class="anchor" name="8620251cbeb5e1458a7438e61ce2854f"></a><!-- doxytag: member="Ogre::CompositorInstance::getEnabled" ref="8620251cbeb5e1458a7438e61ce2854f" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::CompositorInstance::getEnabled           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get enabled flag. 
<p>

</div>
</div><p>
<a class="anchor" name="cac5055f9720fb9b06edffda461e2ebb"></a><!-- doxytag: member="Ogre::CompositorInstance::getTextureInstanceName" ref="cac5055f9720fb9b06edffda461e2ebb" args="(const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::CompositorInstance::getTextureInstanceName           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the instance name for a local texture. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>It is only valid to call this when local textures have been loaded, which in practice means that the compositor instance is active. Calling it at other times will cause an exception. Note that since textures are cleaned up aggressively, this name is not guaranteed to stay the same if you disable and renable the compositor instance. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name of the texture in the original compositor definition </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The instance name for the texture, corresponds to a real texture </dd></dl>

</div>
</div><p>
<a class="anchor" name="b021ecbc3214d82a8ce2702f95e21986"></a><!-- doxytag: member="Ogre::CompositorInstance::_compileTargetOperations" ref="b021ecbc3214d82a8ce2702f95e21986" args="(CompiledState &amp;compiledState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::CompositorInstance::_compileTargetOperations           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance.html#542cbb4277495b83ae702f991c599779">CompiledState</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>compiledState</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Recursively collect target states (except for final <a class="el" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>). 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>compiledState</em>&nbsp;</td><td>This vector will contain a list of <a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html" title="Operation setup for a RenderTarget (collected).">TargetOperation</a> objects </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="5e916aa434bd181800d745ecbaf7399b"></a><!-- doxytag: member="Ogre::CompositorInstance::_compileOutputOperation" ref="5e916aa434bd181800d745ecbaf7399b" args="(TargetOperation &amp;finalState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::CompositorInstance::_compileOutputOperation           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>finalState</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Compile the final (output) operation. 
<p>
This is done seperately because this is combined with the input in chained filters. 
</div>
</div><p>
<a class="anchor" name="714fa12866adad893086d5e9bbc8ca7d"></a><!-- doxytag: member="Ogre::CompositorInstance::getCompositor" ref="714fa12866adad893086d5e9bbc8ca7d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Compositor.html">Compositor</a>* Ogre::CompositorInstance::getCompositor           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get <a class="el" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> of which this is an instance. 
<p>

</div>
</div><p>
<a class="anchor" name="3b91d482e4ab59da5165f021e5db6d83"></a><!-- doxytag: member="Ogre::CompositorInstance::getTechnique" ref="3b91d482e4ab59da5165f021e5db6d83" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositionTechnique.html">CompositionTechnique</a>* Ogre::CompositorInstance::getTechnique           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get <a class="el" href="classOgre_1_1CompositionTechnique.html" title="Base composition technique, can be subclassed in plugins.">CompositionTechnique</a> used by this instance. 
<p>

</div>
</div><p>
<a class="anchor" name="e72e37d6f305e6ae1f1014336e9e2f4b"></a><!-- doxytag: member="Ogre::CompositorInstance::getChain" ref="e72e37d6f305e6ae1f1014336e9e2f4b" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a>* Ogre::CompositorInstance::getChain           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get Chain that this instance is part of. 
<p>

</div>
</div><p>
<a class="anchor" name="d2dcb9ae6aa4e0dfc0843a4cab32f800"></a><!-- doxytag: member="Ogre::CompositorInstance::addListener" ref="d2dcb9ae6aa4e0dfc0843a4cab32f800" args="(Listener *l)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::addListener           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>l</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Add a listener. 
<p>
Listeners provide an interface to "listen in" to to render system operations executed by this <a class="el" href="classOgre_1_1CompositorInstance.html" title="An instance of a Compositor object for one Viewport.">CompositorInstance</a> so that materials can be programmatically set up. <dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html" title="Provides an interface to &quot;listen in&quot; to to render system operations executed...">CompositorInstance::Listener</a> </dd></dl>

</div>
</div><p>
<a class="anchor" name="f0e83615e807bcadef8d6024cda6ec7d"></a><!-- doxytag: member="Ogre::CompositorInstance::removeListener" ref="f0e83615e807bcadef8d6024cda6ec7d" args="(Listener *l)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::removeListener           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html">Listener</a> *&nbsp;</td>
          <td class="paramname"> <em>l</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Remove a listener. 
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1CompositorInstance_1_1Listener.html" title="Provides an interface to &quot;listen in&quot; to to render system operations executed...">CompositorInstance::Listener</a> </dd></dl>

</div>
</div><p>
<a class="anchor" name="62c2d7f611437483668ccf250a4841b9"></a><!-- doxytag: member="Ogre::CompositorInstance::_fireNotifyMaterialSetup" ref="62c2d7f611437483668ccf250a4841b9" args="(uint32 pass_id, MaterialPtr &amp;mat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::_fireNotifyMaterialSetup           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>&nbsp;</td>
          <td class="paramname"> <em>pass_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>mat</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Notify listeners of a material compilation. 
<p>

</div>
</div><p>
<a class="anchor" name="356f66a6f94b53ebbe1fee71f219bfaf"></a><!-- doxytag: member="Ogre::CompositorInstance::_fireNotifyMaterialRender" ref="356f66a6f94b53ebbe1fee71f219bfaf" args="(uint32 pass_id, MaterialPtr &amp;mat)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::_fireNotifyMaterialRender           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a>&nbsp;</td>
          <td class="paramname"> <em>pass_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>mat</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Notify listeners of a material render. 
<p>

</div>
</div><p>
<a class="anchor" name="71e09eaa840d87b42bc149c06aa3e0ff"></a><!-- doxytag: member="Ogre::CompositorInstance::collectPasses" ref="71e09eaa840d87b42bc149c06aa3e0ff" args="(TargetOperation &amp;finalState, CompositionTargetPass *target)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::CompositorInstance::collectPasses           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>finalState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositionTargetPass.html">CompositionTargetPass</a> *&nbsp;</td>
          <td class="paramname"> <em>target</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [private, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Collect rendering passes. 
<p>
Here, passes are converted into render target operations and queued with queueRenderSystemOp. 
</div>
</div><p>
<a class="anchor" name="b730d261e3ce8c2d3dbd675f056e8966"></a><!-- doxytag: member="Ogre::CompositorInstance::createLocalMaterial" ref="b730d261e3ce8c2d3dbd675f056e8966" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> Ogre::CompositorInstance::createLocalMaterial           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a local dummy material with one technique but no passes. 
<p>
The material is detached from the <a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> Manager to make sure it is destroyed when going out of scope. 
</div>
</div><p>
<a class="anchor" name="909fc5fda3e32e14a32bfde7b44d4a6a"></a><!-- doxytag: member="Ogre::CompositorInstance::createResources" ref="909fc5fda3e32e14a32bfde7b44d4a6a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::createResources           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create local rendertextures and other resources. 
<p>
Builds mLocalTextures. 
</div>
</div><p>
<a class="anchor" name="a594fe3eaf57f5e206e5d4c847d77074"></a><!-- doxytag: member="Ogre::CompositorInstance::freeResources" ref="a594fe3eaf57f5e206e5d4c847d77074" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::freeResources           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Destroy local rendertextures and other resources. 
<p>

</div>
</div><p>
<a class="anchor" name="a7f2a073b8295994eb1d0c73dcb9f166"></a><!-- doxytag: member="Ogre::CompositorInstance::getTargetForTex" ref="a7f2a073b8295994eb1d0c73dcb9f166" args="(const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RenderTarget.html">RenderTarget</a>* Ogre::CompositorInstance::getTargetForTex           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get <a class="el" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> for a named local texture. 
<p>

</div>
</div><p>
<a class="anchor" name="1a3f491817519cfdf1824222dcdf6ea6"></a><!-- doxytag: member="Ogre::CompositorInstance::getSourceForTex" ref="1a3f491817519cfdf1824222dcdf6ea6" args="(const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::CompositorInstance::getSourceForTex           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get source texture name for a named local texture. 
<p>

</div>
</div><p>
<a class="anchor" name="a251665019c7f50e2920c317e842d933"></a><!-- doxytag: member="Ogre::CompositorInstance::queueRenderSystemOp" ref="a251665019c7f50e2920c317e842d933" args="(TargetOperation &amp;finalState, RenderSystemOperation *op)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::CompositorInstance::queueRenderSystemOp           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance_1_1TargetOperation.html">TargetOperation</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>finalState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1CompositorInstance_1_1RenderSystemOperation.html">RenderSystemOperation</a> *&nbsp;</td>
          <td class="paramname"> <em>op</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Queue a render system operation. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>destination pass </dd></dl>

</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="37ae5ce58afd2f0684c967bb1e780f58"></a><!-- doxytag: member="Ogre::CompositorInstance::CompositorChain" ref="37ae5ce58afd2f0684c967bb1e780f58" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a><code> [friend]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00261">261</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="d527be1fedec4112efe9eb3ff8f6b925"></a><!-- doxytag: member="Ogre::CompositorInstance::mCompositor" ref="d527be1fedec4112efe9eb3ff8f6b925" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Compositor.html">Compositor</a>* <a class="el" href="classOgre_1_1CompositorInstance.html#d527be1fedec4112efe9eb3ff8f6b925">Ogre::CompositorInstance::mCompositor</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
<a class="el" href="classOgre_1_1Compositor.html" title="Class representing a Compositor object.">Compositor</a> of which this is an instance. 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00211">211</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3d3a380fb753ad28cc3119d0f15868a4"></a><!-- doxytag: member="Ogre::CompositorInstance::mTechnique" ref="3d3a380fb753ad28cc3119d0f15868a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositionTechnique.html">CompositionTechnique</a>* <a class="el" href="classOgre_1_1CompositorInstance.html#3d3a380fb753ad28cc3119d0f15868a4">Ogre::CompositorInstance::mTechnique</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Composition technique used by this instance. 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00213">213</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="beb0b38cce2a6c765390544d054a75cf"></a><!-- doxytag: member="Ogre::CompositorInstance::mChain" ref="beb0b38cce2a6c765390544d054a75cf" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositorChain.html">CompositorChain</a>* <a class="el" href="classOgre_1_1CompositorInstance.html#beb0b38cce2a6c765390544d054a75cf">Ogre::CompositorInstance::mChain</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Composition chain of which this instance is part. 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00215">215</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e14d9e70c48e35de5a49ebf29777a8f7"></a><!-- doxytag: member="Ogre::CompositorInstance::mEnabled" ref="e14d9e70c48e35de5a49ebf29777a8f7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1CompositorInstance.html#e14d9e70c48e35de5a49ebf29777a8f7">Ogre::CompositorInstance::mEnabled</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Is this instance enabled? 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00217">217</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="fb44967dff9b29465e5e5ea7aa9d67ff"></a><!-- doxytag: member="Ogre::CompositorInstance::mLocalTextures" ref="fb44967dff9b29465e5e5ea7aa9d67ff" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositorInstance.html#a376bba92a454473511b2d85dd7a1bf1">LocalTextureMap</a> <a class="el" href="classOgre_1_1CompositorInstance.html#fb44967dff9b29465e5e5ea7aa9d67ff">Ogre::CompositorInstance::mLocalTextures</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00220">220</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4476eeba8785b7684dcc83e3a8bb7d31"></a><!-- doxytag: member="Ogre::CompositorInstance::mListeners" ref="4476eeba8785b7684dcc83e3a8bb7d31" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositorInstance.html#6a4983aa7ac3560bd2b0f2eb05c3a917">Listeners</a> <a class="el" href="classOgre_1_1CompositorInstance.html#4476eeba8785b7684dcc83e3a8bb7d31">Ogre::CompositorInstance::mListeners</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00224">224</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="cdac0c97861080d95c032ef8c21721e3"></a><!-- doxytag: member="Ogre::CompositorInstance::mPreviousInstance" ref="cdac0c97861080d95c032ef8c21721e3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1CompositorInstance.html">CompositorInstance</a>* <a class="el" href="classOgre_1_1CompositorInstance.html#cdac0c97861080d95c032ef8c21721e3">Ogre::CompositorInstance::mPreviousInstance</a><code> [private]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Previous instance (set by chain). 
<p>

<p>Definition at line <a class="el" href="OgreCompositorInstance_8h-source.html#l00227">227</a> of file <a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreCompositorInstance_8h-source.html">OgreCompositorInstance.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:25 2008
</p>
</body>
</html>
